#pragma once
/*	
*	AZN_TSuperSplash.h
*
*	Class declaration for 'TSuperSplash' class, a class
*	to put up and manage a splash screen
*	Inheritance:	BASE CLASS
*
*	 Andrew Nemeth  Warrimoo  Australia  1995
*	aznemeng@zeta.org.au
*
*	File opened:		20 Jul 95
*	File ammended:		2023 Jul;
*					16 Sep;
*					20 Oct 95.
*/


//	CLASS dec
//
class	TSuperSplash
{
	public:
		TSuperSplash();
		TSuperSplash( const short /*PICT res ID*/ );
		TSuperSplash( ConstStr63Param /*Filename*/ );
		
		~TSuperSplash();

		Boolean			showSplash			( void );
		Boolean			showSplash			( const FSSpec & /*Image file*/ );
		void				killSplash			( void );

		static Boolean	hasColourQD			( void );

	private:
		GrafPtr			f_OldGrafPort;
		WindowPtr			f_ptrWind;
		PicHandle			f_hPict;
		short			f_shPictRes_ID;
		Str63			f_str63FileName;
		Boolean			f_boolBigImg;

		void				drawSplash			( PicHandle );

		OSErr			grabNamedFile			( ConstStr63Param, FSSpecPtr );
		OSErr			grabPictHandleFromFile	( const FSSpec &, PicHandle * );
		OSErr			grabVol_ParId			( short *, long * );
		Boolean			isFileOfType			( const FSSpec &, const OSType );
		Boolean			quicktimeAvailable		( void );
		void				centreWindow			( WindowPtr, Boolean /*ALRT pos?*/ );
		
//														prevent copy/ assign of class
	private:
		TSuperSplash  &  	operator=( const TSuperSplash & );
		TSuperSplash( const TSuperSplash & );
};
